# -*- coding: utf-8 -*-

from ZCL import *
#from BATCH_FRAME import *


#### FULL Standard frame description ####################e####
STDFrame = Struct(
	"FrameCtrl" / FrameCtrl,
	"CommandID" / CommandID,
	"ClusterID" / ClusterID,
	Embedded ( 
		If ( ((this.CommandID == "ConfigureReportingResponse") | 
			  (this.CommandID == "ReadReportingConfigurationResponse")),
				Struct("Status" / Status))),
	Embedded ( 
		If ( ((this.CommandID == "ConfigureReporting") | 
			  (this.CommandID == "ReadReportingConfiguration") | 
			  (this.CommandID == "ConfigureReportingResponse") | 
			  (this.CommandID == "ReadReportingConfigurationResponse")),
				Struct("Direction" / Direction))),
	Embedded (
		If ( (this.CommandID != "ClusterSpecificCommand"), 
				Struct("AttributeID" / AttributeID))),
	Embedded ( 
		If ( (this.CommandID == "ReadAttributeResponse"),
				Struct("Status" / Status))),
	Embedded ( 
		If ( ((this.CommandID == "ReadAttributeResponse") |
			  (this.CommandID == "ConfigureReporting") |
			  (this.CommandID == "ReadReportingConfigurationResponse") |
			  (this.CommandID == "ReportAttributesAlarm") |
			  (this.CommandID == "ReportAttributes")),
				Struct("AttributeType" / DataType))),
	Embedded ( 
		If ( ((this.CommandID == "ConfigureReporting") |
			  (this.CommandID == "ReadReportingConfigurationResponse")),
				Struct(
					"MinReport" / MinReport,
					"MaxReport" / MaxReport,
				))),
	Embedded ( 
		If ( ((this.CommandID == "ReadAttributeResponse") |
			  (this.CommandID == "ConfigureReporting") |
			  (this.CommandID == "ReadReportingConfigurationResponse") |
			  (this.CommandID == "ReportAttributesAlarm") |
			  (this.CommandID == "ReportAttributes") |
			  (this.CommandID == "ClusterSpecificCommand")),
				Struct( "Data" / Data )))
)


